#include "stm32f0xx_hal.h"
#include "misc.h"



//
void pulse_gpio_init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    
    __HAL_RCC_GPIOA_CLK_ENABLE();

    GPIO_InitStruct.Pin = GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2 | GPIO_PIN_3;
    GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
    GPIO_InitStruct.Pull = GPIO_PULLUP;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
}


//
uint16_t get_pulse_len(void)
{
    uint16_t tmp = 0;
    
    tmp = (uint8_t)HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_0);
    tmp |= (uint8_t)HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) << 1;
    tmp |= (uint8_t)HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_2) << 2;
    tmp |= (uint8_t)HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_3) << 3;
    tmp = ~tmp & 0x0F;    
    
    return tmp*60 + 100;
}